*******************************************************************************;
* vO: P01-07-02.SAS                                                 *;
* eLXg̏: Ṕ@SAS/RpX͎̉                         *;
* eLXg̐: V߁@dr                                            *;
* gpړI: Tukey̑dr                                                   *;
* Date: 2017/2/3  Version: 1.0                                                *;
*******************************************************************************;

* ----- o͐ݒ;
options linesize=80 pagesize=66 nodate;
title 'Title: Tukey̑dr';
footnote 'Program: P01-07-02.SAS';

* ----- Tvf[^쐬;
data TUKEY;
  input DRUG $ PRE POST @@ ;
  DIF=PRE-POST;
  cards;
P 295 305  P 374 303  P 201 221  P 256 328  P 218 299 P 204 330  P 317 353  
P 291 308  P 301 436  P 353 272  P 393 391  P 355 318 P 284 292  P 348 349  
P 234 257  P 311 271  P 223 291  P 382 349  P 348 271 P 340 325  P 345 422  
P 298 312  P 317 228  P 334 290  P 353 386  P 366 299 P 346 243  P 382 298  
P 310 268  P 257 336  P 332 263  P 259 277  P 268 337 P 287 249  P 336 356  
P 222 302  P 312 212  P 352 348  P 345 320  P 339 323 C 246 359  C 370 350  
C 298 251  C 275 292  C 261 308  C 282 299  C 292 292 C 377 359  C 284 379  
C 429 231  C 229 287  C 406 297  C 344 268  C 238 297 C 292 336  C 294 344  
C 273 287  C 246 349  C 333 269  C 241 257  C 326 210 C 317 267  C 264 289  
C 314 323  C 278 355  C 250 293  C 342 347  C 375 244 C 333 364  C 221 289  
C 341 271  C 372 387  C 269 332  C 284 251  C 280 314 C 338 417  C 277 324  
C 350 397  C 392 259  C 403 331  A 322 270  A 397 329 A 365 396  A 225 172  
A 271 222  A 290 292  A 294 199  A 306 317  A 409 243 A 277 269  A 337 288  
A 306 257  A 291 298  A 268 115  A 308 268  A 420 218 A 181 301  A 277 211  
A 354 332  A 254 267  A 263 279  A 338 133  A 404 143 A 351 263  A 264 182  
A 232 247  A 420 310  A 316 267  A 309 337  A 351 287 A 321 271  A 294 352  
A 289 318  A 352 283  A 375 317  A 304 350  A 283 282 A 333 284  A 325 308  
A 293 190                                                                   
;
run ;

proc print data=TUKEY;
run;

* ----- MIXEDvVWɂTukey̑dr;
ods output Diffs=OUT1;
 
proc mixed data=TUKEY order=data;
  class DRUG;
  model DIF=DRUG;
  lsmeans DRUG/adjust=tukey pdiff cl;
run;

proc print data=OUT1;
run;

* ----- PROBMC֐pTukey̑dr;
data TUKEY;set TUKEY;
  IF DRUG="P" then DRUG=0;
  IF DRUG="C" then DRUG=1;
  IF DRUG="A" then DRUG=2;
run;
    
proc summary data=TUKEY;
  class DRUG;
  var DIF;
  output out=SUMMARY mean=MEAN css=CSS n=N;
run;

data _null_;
  set SUMMARY end=EOF;
  if EOF then call symput('G_NUM',left(_n_-1));
run;

data STAT;set SUMMARY end=EOF;
  array MU{&G_NUM} MEAN1-MEAN&G_NUM;
  array NO{&G_NUM} N1-N&G_NUM;
  keep MEAN1-MEAN&G_NUM N1-N&G_NUM S DF;
  retain MU NO S DF;
  if _n_=1 then do;
    S=0;
    DF=N;
  end;
  if _n_>=2 then do;
    MU{_n_-1}=MEAN;
    NO{_n_-1}=N;
    S=S+CSS;
  end;
  if EOF then do;
    DF=DF-&G_NUM;
    S=sqrt(S/DF);
    output;
  end;
run;

data STAT; set STAT;
  array MU{&G_NUM} MEAN1-MEAN&G_NUM;
  array NO{&G_NUM} N1-N&G_NUM;
  do I=1 to &G_NUM-1;
    do J=I+1 to &G_NUM;
      TESTSTAT=(MU{J}-MU{I})/(S*SQRT(1/NO{J}+1/NO{I}));
      PVAL=1-probmc("range",abs(TESTSTAT)*sqrt(2),.,DF,&G_NUM);
      output;
    end;
  end;
run;

proc print data=STAT;
  var I J TESTSTAT PVAL;
run;

* ----- MULTTESTvVWɂTukey̑dr;
proc multtest data=TUKEY permutation order=data out=OUT nsample=1000000 
  seed=1697 noprint;
  class DRUG;
  test mean(DIF);
  contrast '1-2' -1  1  0;
  contrast '1-3' -1  0  1;
  contrast '2-3'  0 -1  1;
run;

proc print data=OUT;
  var _CONTRAST_ PERM_P;
run;
