*******************************************************************************;
* vO: P01-07-06.SAS                                                 *;
* eLXg̏: Ṕ@SAS/RpX͎̉                         *;
* eLXg̐: V߁@dr                                            *;
* gpړI: Shirley-Williams(mpgbNłWilliams̑dr)    *;
* Date: 2017/2/3  Version: 1.0                                                *;
*******************************************************************************;

* ----- o͐ݒ;
options linesize = 80 pagesize = 66 nodate;
title 'Title: Shirley-Williams(mpgbNłWilliams̑dr)';
footnote 'Program: P01-07-06.SAS';

* ---- f[^쐬 ;
data dt(drop=i);
  do group = 1 to 4;
    do i = 1 to 12;
      input resp @@; output;
    end;
  end;
cards;
13 23  8 17 25 34 18 26 10 28 18 21
26 22 30 38 15 24 18 11 21 30 31 23
22 10 29 37 22 13 29 28 21 16 21 26
26 34 30 45 17 19 27 18 36 24 25 31
;
run;

* ---- Shirley-Williams ;
%macro S_WILL;
data data;
  set &data;
  do stage = 2 to &g;
    if &group <= stage then output;
  end;

proc sort data = data;
  by stage &group;
run;

proc rank data = data  out = rank;
  var &y;
  ranks rank;
  by stage;
run;

proc summary data = rank;
  var rank;
  class &group;
  output out = out  mean = mean  var = var  n = n;
  by stage;
run;

data out (keep = stage &group mean n)
  var (keep = var stage &group);
  set out;
  if _type_ = 0 then output var;
  else output out;
run;

proc transpose data = out  out = n  prefix = n;
  var n;
  id &group;
  by stage;
run;

proc transpose data = out  out = mean  prefix = m;
  var mean;
  id &group;
  by stage;
run;

data summary;
  merge n mean var;
  by stage;
run;

data summary;
  set summary;
  drop s1 - s100 nn1 - nn100;
  keep control g mean adjmean z wp wzc stage;
  array  nn(&g)     n1 -   n&g;
  array   m(&g)     m1 -   m&g;
  array  mm(&g)    mm1 -  mm&g;
  array   s(10,10)  s1 -  s100;
  array nnn(10,10) nn1 - nn100;
  mm1 = m1;
  df = .;

*----- calculation of adjusted mean --------------;
  do ii = 1 to &g - 1;
    do jj = 1 to &g - 1; s(ii,jj) = 0; nnn(ii,jj) = 0;
      do kk = ii to jj; s(ii,jj) = s(ii,jj) + m(kk+1) * nn(kk+1); nnn(ii,jj) = nnn(ii,jj) + nn(kk + 1); 
      end;
      if nnn(ii,jj) ne 0 then s(ii,jj) = s(ii,jj)/nnn(ii,jj);
    end;
  end;

  do jj = 1 to &g - 1; mm(jj + 1) = m(jj + 1);
    do ii = 1 to &g - 1;
      if nnn(ii,jj) ne 0 and 1 = &tail then mm(jj + 1) = max(mm(jj + 1),s(ii,jj));
      if nnn(ii,jj) ne 0 and 2 = &tail then mm(jj + 1) = min(mm(jj + 1),s(ii,jj));
    end;
  end;
  do ii = &g to 2 by -1;
    control = mm1; 
    g       = ii; 
    adjmean = mm(ii);
    mean    = m(ii);
    z       = (mm(ii) - mm1) / (var * (1 / nn(ii) + 1 / n1)) ** .5;
    if 2 = &tail then z = z * (-1);
    wp  = 1 - probmc('williams',z,.,df,ii -1);
    wzc = probmc('williams',.,1 - &a,df,ii - 1);
    if stage = g then output;
  end;
run;
proc sort;
  by descending stage;
run;

data summary;
  set summary;
  retain sin 0;
  star = '';
  if stage = &g then sin = 1;
  if wp ge &a then sin = 0;
  if sin = 1 and wp lt &a then star = '*';
run;

proc sort;
  by stage;
run;

proc print;
  var stage control g mean adjmean z wp wzc star;
run;

%mend;

%let  data =    dt; *DS;
%let     g =     4; *ΏƌQ܂ތQ̐;
%let     y =  resp; *ϐ;
%let group = group; *Qϐ;
%let     a =  0.05; *LӐ;
%let  tail =     1; *1(㑤);

%S_WILL;

