*******************************************************************************;
* vO: P02-02-01.SAS                                                 *;
* eLXg̏: Q́@SAS/RpX̗ᐔ݌v                     *;
* eLXg̐: Q߁@QQ̔r                                      *;
* gpړI: vʒl̗Dz̗ᐔ߂                                  *;
* Date: 2017/2/3  Version: 1.0                                                *;
*******************************************************************************;

* ----- o͐ݒ;
options linesize=80 pagesize=66 nodate;
title 'Title: vʒl̗Dz̗ᐔ߂';
footnote 'Program: P02-02-01.SAS';

*---  vʒl̗Dz̗ᐔ݌v ---*;
/*-----p[^w---------------------------------------------------------*/
/*  MU_A   :     팱A̕ϒl                                              */
/*  MU_B   :     ΏƖB̕ϒl                                              */
/*  SD     :     2Q̋ʂ̕W΍                                          */
/*  ALPHA  :     LӐ(P̉ߌ)                                       */
/*  BETA   :     2̉ߌ                                                  */
/*  PSI    :     2Q̏Ǘᐔ̔(B/A)                                         */
/*----------------------------------------------------------------------------*/
%macro PR(MU_A, MU_B, SD, ALPHA, BETA, PSI);
  data WORK1;
    MU_A=&MU_A;
    MU_B=&MU_B;
    SD=&SD;
    ALPHA=&ALPHA;
    BETA=&BETA;
    PSI=&PSI;
    D=abs(MU_B - MU_A);
    ZALPHA=probit(1-ALPHA/2);
    ZBETA=probit(1-BETA);
    N=(1+1/psi)*((ZALPHA+ZBETA)**2)*((SD/D)**2);
  run;

  proc print data=WORK1;
    var MU_A MU_B SD ALPHA BETA PSI ZALPHA ZBETA N;
  run;
%mend;

%PR(60, 50, 20, 0.05, 0.2, 1);

*--- POWERvVWpꍇ ---*;
proc power;
  twosamplemeans test = diff
  groupmeans     = 60 | 50
  stddev         = 20
  alpha          = 0.05
  power          = 0.80
  groupweights   = (1 1)
  ntotal         = .;
run;

*---  vʒl̗Džo ---*;
/*-----p[^w---------------------------------------------------------*/
/*  MU_A   : 팱A̕ϒl                                                  */
/*  MU_B   : ΏƖB̕ϒl                                                  */
/*  SD     : 2Q̋ʂ̕W΍                                              */
/*  ALPHA  : LӐ(P̉ߌ)                                           */
/*  PSI    : 2Q̏Ǘᐔ̔(B/A)                                             */
/*  N      : AQ̏Ǘᐔ                                                      */
/*----------------------------------------------------------------------------*/
%macro POWER(MU_A, MU_B, SD, ALPHA, PSI, N);
  data WORK2;
    MU_A=&MU_A;
    MU_B=&MU_B;
    SD=&SD;
    ALPHA=&ALPHA;
    PSI=&PSI;
    N=&N;
    D=abs(MU_B - MU_A);
    ZALPHA=probit(1-ALPHA/2);
    ZBETA=D/SD*(1/sqrt((1+1/psi)/n))-ZALPHA;
    POWER=probnorm(ZBETA);
  run;

  proc print data=WORK2;
    var MU_A MU_B SD ALPHA PSI N ZALPHA ZBETA POWER;
  run;
%mend;

%POWER(60, 50, 20, 0.05, 1, 90); 

*--- POWERvVWpꍇ ---*;
proc power;
  twosamplemeans test = diff
  groupmeans     = 60 | 50
  stddev         = 20
  alpha          = 0.05
  power          = .
  groupweights   = (1 1)
  ntotal         = 180;
run;
