*******************************************************************************;
* vO: P02-03-01.SAS                                                 *;
* eLXg̏: Q́@SAS/RpX̗ᐔ݌v                     *;
* eLXg̐: R߁@pʔ                                        *;
* gpړI: vʒl̗pʔ̗ᐔ߂iΔɂ錟j              *;
* Date: 2017/2/3  Version: 1.0                                                *;
*******************************************************************************;

* ----- o͐ݒ;
options linesize=80 pagesize=66 nodate;
title 'Title: vʒl̗pʔ̗ᐔ߂iΔɂ錟j';
footnote 'Program: P02-03-01.SAS';

*--- vʒl̗pʔ̗ᐔ݌v(Δɂ錟) ---*;
/*-----p[^w---------------------------------------------------------*/
/*  ALPHA  : LӐ(P̉ߌ)                                           */
/*  BETA   : 2̉ߌ                                                      */
/*  MVAR   : eQ̐蕽ϒlBlank؂œ                              */
/*  CVAR   : eQ̑ΔWBlank؂œ                                */
/*  SD     : W΍                                                         */
/*  K      : Q̐                                                           */
/*   : MVAR/CVAŔA1Qڂ̒l̒OɂBlankK͂ĉ      */
/*----------------------------------------------------------------------------*/
%macro CONTRAST(ALPHA, BETA, MVAR, CVAR, SD, K);
  data DATA1;
    retain NUM_ DENOM_ 0;
  * ----- p[^w;
    ALPHA=&ALPHA;
    BETA=&BETA;
  * ----- vZ;
    Z_ALPHA=probit(1-ALPHA);
    Z_BETA =probit(1-BETA);
  * ----- ᐔvZ;
    %do I=1 %to &K;
      %let M&I=%scan(&MVAR, &I, ' ');
      %let C&I=%scan(&CVAR, &I, ' ');
      NUM_=NUM_+(&&C&I)**2;
      DENOM_=DENOM_+(&&C&I)*(&&M&I);
    %end;
    NUM=(Z_ALPHA+Z_BETA)**2*NUM_*(&SD**2);
    DENOM=DENOM_**2;
    N=NUM/DENOM;
  run;

  proc print data=DATA1;
    var ALPHA BETA Z_ALPHA Z_BETA N;
  run;
%mend CONTRAST;

%CONTRAST(0.025, 0.20, 97.5 95 92.5 90, 3 1 -1 -3, 10, 4); 

%macro TREND4(R,N,ALPHA,M1,M2,M3,M4,SIGMA,SEED);
data DT01;
  * ----- p[^w;
  R=&R;
  N=&N;
  M1=&M1;
  M2=&M2;
  M3=&M3;
  M4=&M4;
  SIGMA=&SIGMA;
  SEED=&SEED;

  * ----- ̔;
  do I=1 to R;
    GROUP=1; 
    do J=1 to N; 
      Y=M1+rannor(SEED)*SIGMA; 
      output; 
    end;
    
    GROUP=2; 
    do j=1 to n; 
      y=m2+rannor(SEED)*SIGMA; 
      output; 
    end;
    
    GROUP=3; 
    do j=1 to n; 
      y=m3+rannor(SEED)*SIGMA; 
      output; 
    end;
    
    GROUP=4; 
    do j=1 to n; 
      y=m4+rannor(SEED)*SIGMA; 
      output; 
    end;
  end;
run;

* ----- V~[V{;
proc multtest data=DT01 out=OUT1 noprint;
  test mean(Y);
  class GROUP;
  by I;
  contrast 'linear' -3 -1 1 3;
run;

* ----- LӐ̃`FbN;
data OUT2;
  set OUT1;
  ALPHA=&ALPHA;
  if RAW_P < ALPHA then JUDGE=1;
  else JUDGE=0;
run;

proc freq data=OUT2;
  tables JUDGE;
run;
%mend TREND4;

%TREND4(10000,26,0.05,97.5,95,92.5,90,10,12345);

*--- POWERvVWpꍇ ---*;
proc power;
  onewayanova
  groupmeans     = 97.7 | 95.0 | 92.5 | 90.0
  sides          = 1
  stddev         = 10
  alpha          = 0.025
  npergroup      = .
  power          = 0.80
  contrast       = (-3 -1 1 3);
run;
