*******************************************************************************;
* vO: P02-05-01.SAS                                                 *;
* eLXg̏: Q́@SAS/RpX̗ᐔ݌v                     *;
* eLXg̐: T߁@ԉ                                        *;
* gpړI: ԉ͂ɂėᐔ߂                                  *;
* Date: 2017/2/3  Version: 1.0                                                *;
*******************************************************************************;

* ----- o͐ݒ;
options linesize=80 pagesize=66 nodate;
title 'Title: ԉ͂ɂėᐔ߂';
footnote 'Program: P02-05-01.SAS';

*---  ԉ̗͂ᐔ݌v  ---*;
/*-----p[^w---------------------------------------------------------*/
/*  R      : 󂯓                                                     */
/*  T      : ǐՊ                                                         */
/*  TIME   : TIMEN                                                     */
/*  A      : 100A(%)(<1)                                                */
/*  B      : 100B(%)(<1)                                                */
/*  ALPHA  : LӐ(<1)                                                     */
/*  BETA   : ói1-BETAj                                                 */
/*  S      : ᐔ(Na/Nb)                                                    */
/* -------------------------------------------------------------------------- */
%macro SURVIVAL(R,T,TIME,A,B,ALPHA,BETA,S);
  DATA D1;
  * ------------------------------------------------p[^w;
    ALPHA=&ALPHA;
    BETA=&BETA;
    R=&R;
    T=&T;
    LA=-log(&A)/&TIME;
    LB=-log(&B)/&TIME;
    LBER=(LA+LB)/2;
    S=&S;
    QA=S/(1+S);
    QB=1/(1+S);
  * ------------------------------------------------vZ;
    ZA=probit(1-ALPHA/2);
    ZB=probit(1-BETA);
  *-------------------------------------------------e탳()̌vZ;
    P00=LBER*LBER;
    P01=LA*LA;
    P02=LB*LB;
    P10=LBER**2/(1-exp(-LBER*T));
    P11=LA**2/(1-exp(-LA*T));
    P12=LB**2/(1-exp(-LB*T));
    P20=LBER**3*T/(LBER*T-1+exp(-LBER*T));
    P21=LA**3*T/(LA*T-1+exp(-LA*T));
    P22=LB**3*T/(LB*T-1+exp(-LB*T));
    P30=LBER**2*(1-(exp(-LBER*(T-R))-exp(-LBER*T))/(LBER*R))**(-1);
    P31=LA**2*(1-(exp(-LA*(T-R))-exp(-LA*T))/(LA*R))**(-1);
    P32=LB**2*(1-(exp(-LB*(T-R))-exp(-LB*T))/(LB*R))**(-1);
  *-------------------------------------------------eᐔ̌vZ;
    N=((ZA*sqrt(P00*(1/QB+1/QA))+ZB*sqrt(P01/QA+P02/QB))/abs(LA-LB))**2/(1+S);
    M=((ZA*sqrt(P10*(1/QB+1/QA))+ZB*sqrt(P11/QA+P12/QB))/abs(LA-LB))**2/(1+S);
    O=((ZA*sqrt(P30*(1/QB+1/QA))+ZB*sqrt(P31/QA+P32/QB))/abs(LA-LB))**2/(1+S);
    L=((ZA*sqrt(P20*(1/QB+1/QA))+ZB*sqrt(P21/QA+P22/QB))/abs(LA-LB))**2/(1+S);
    Label N="R=0,T=" M="R=0,T>0" L="0< R=T" O="0< R < T" T="" 
          R="󂯓" LA="nU[hA" LB="nU[hB";
  run;

  proc print label;
    var S R T LA LB ALPHA ZA BETA ZB N M O L;
  run;
%mend;

%SURVIVAL(3,5,5,0.2,0.05,0.05,0.2,1); 

*--- POWERvVWpꍇ ---*;
proc power; 
   twosamplesurvival test=logrank 
   curve("Control")   = (5):(0.05) 
   curve("Treatment") = (5):(0.20) 
   groupsurvival = "Control" | "Treatment" 
   accrualtime = 3 
   followuptime =2 
   npergroup =. 
   power =0.80; 
run;
